--- ircd-hybrid-6.0/include/channel.h.orig	Thu Feb  8 22:49:23 2001
+++ ircd-hybrid-6.0/include/channel.h	Thu Feb  8 22:49:26 2001
@@ -144,7 +144,6 @@
 #define MODE_CHANOP     CHFL_CHANOP
 #define MODE_VOICE      CHFL_VOICE
 #define MODE_DEOPPED    CHFL_DEOPPED
-#define MODE_PRIVATE    0x0008
 #define MODE_SECRET     0x0010
 #define MODE_MODERATED  0x0020
 #define MODE_TOPICLIMIT 0x0040
@@ -203,12 +202,11 @@
 /* name invisible */
 #define SecretChannel(x)        ((x) && ((x)->mode.mode & MODE_SECRET))
 /* channel not shown but names are */
-#define HiddenChannel(x)        ((x) && ((x)->mode.mode & MODE_PRIVATE))
+#define HiddenChannel(x)        ((x) && ((x)->mode.mode & MODE_SECRET))
 /* channel visible */
 #define ShowChannel(v,c)        ((c)->users && \
 				 (SeesAllConnections(v) || PubChannel(c) || IsMember((v),(c))))
-#define PubChannel(x)           ((!x) || ((x)->mode.mode &\
-                                 (MODE_PRIVATE | MODE_SECRET)) == 0)
+#define PubChannel(x)           ((!x) || ((x)->mode.mode & MODE_SECRET) == 0)
 
 #define IsMember(blah,chan) ((blah && blah->user && \
                 find_channel_link((blah->user)->channel, chan)) ? 1 : 0)
--- ircd-hybrid-6.0/src/channel.c.orig	Thu Feb  8 22:37:34 2001
+++ ircd-hybrid-6.0/src/channel.c	Thu Feb  8 22:57:43 2001
@@ -818,16 +818,6 @@
   *mbuf++ = '+';
   if (chptr->mode.mode & MODE_SECRET)
     *mbuf++ = 's';
-
-  /* bug found by "is" ejb@debian.org */
-#ifdef OLD_P_S
-  else if (chptr->mode.mode & MODE_PRIVATE)
-    *mbuf++ = 'p';
-#else
-  if (chptr->mode.mode & MODE_PRIVATE)
-    *mbuf++ = 'p';
-#endif
-
   if (chptr->mode.mode & MODE_MODERATED)
     *mbuf++ = 'm';
   if (chptr->mode.mode & MODE_TOPICLIMIT)
@@ -2093,31 +2083,11 @@
                   chptr->mode.mode &= ~MODE_SECRET;
                 }
 #endif
-#ifdef OLD_NON_RED
-              if(!(chptr->mode.mode & MODE_PRIVATE))
-#endif
-                {
-                  chptr->mode.mode |= MODE_PRIVATE;
-                  *mbufw++ = '+';
-                  *mbufw++ = 'p';
-                  len += 2;
-                  /*              opcnt++; */
-                }
             }
           else
             {
               if (len + 2 >= MODEBUFLEN)
                 break;
-#ifdef OLD_NON_RED
-              if(chptr->mode.mode & MODE_PRIVATE)
-#endif
-                {
-                  chptr->mode.mode &= ~MODE_PRIVATE;
-                  *mbufw++ = '-';
-                  *mbufw++ = 'p';
-                  len += 2;
-                  /*              opcnt++; */
-                }
             }
           break;
 
@@ -2153,17 +2123,6 @@
             {
               if (len + 2 >= MODEBUFLEN)
                 break;
-#ifdef OLD_P_S
-              if(chptr->mode.mode & MODE_PRIVATE)
-                {
-                  if (len + 2 >= MODEBUFLEN)
-                    break;
-                  *mbufw++ = '-';
-                  *mbufw++ = 'p';
-                  len += 2;
-                  chptr->mode.mode &= ~MODE_PRIVATE;
-                }
-#endif
 #ifdef OLD_NON_RED
               if(!(chptr->mode.mode & MODE_SECRET))
 #endif
@@ -3970,41 +3929,6 @@
       if (acptr->user->away)
         sendto_one(sptr, form_str(RPL_AWAY), me.name, parv[0],
                    acptr->name, acptr->user->away);
-      
-      if( need_invite )
-        {
-          /* Send a NOTICE to all channel operators concerning chanops who  *
-           * INVITE other users to the channel when it is invite-only (+i). *
-           * The NOTICE is sent from the local server.                      */
-
-          /* Only allow this invite notice if the channel is +p
-           * i.e. "paranoid"
-           * -Dianora
-           */
-
-          if (chptr && (chptr->mode.mode & MODE_PRIVATE))
-            { 
-              char message[NICKLEN*2+CHANNELLEN+USERLEN+HOSTLEN+30];
-
-              /* bit of paranoia, be a shame if it cored for this -Dianora */
-              if(acptr->user)
-                {
-                  ircsprintf(message,
-                             "INVITE: %s (%s invited %s [%s@%s])",
-                             chptr->chname,
-                             sptr->name,
-                             acptr->name,
-                             acptr->username,
-                             acptr->host);
-
-                  sendto_channel_type(cptr, sptr, chptr,
-                                      MODE_CHANOP,
-                                      chptr->chname,
-                                      "PRIVMSG",
-                                      message);
-                }
-            }
-        }
     }
 
   if(MyConnect(acptr) && need_invite)
@@ -4358,7 +4282,7 @@
         mode.mode |= MODE_NOPRIVMSGS;
         break;
       case 'p':
-        mode.mode |= MODE_PRIVATE;
+        mode.mode |= MODE_SECRET;
         break;
       case 's':
         mode.mode |= MODE_SECRET;
@@ -4524,15 +4448,6 @@
       }
       */
 
-  if((MODE_PRIVATE    & mode.mode) && !(MODE_PRIVATE    & oldmode->mode))
-    {
-      if (what != 1)
-        {
-          *mbuf++ = '+';
-          what = 1;
-        }
-      *mbuf++ = 'p';
-    }
   if((MODE_SECRET     & mode.mode) && !(MODE_SECRET     & oldmode->mode))
     {
       if (what != 1)
@@ -4604,15 +4519,6 @@
         *mbuf++ = flags[ip].letter;
       }
       */
-  if((MODE_PRIVATE    & oldmode->mode) && !(MODE_PRIVATE    & mode.mode))
-    {
-      if (what != -1)
-        {
-          *mbuf++ = '-';
-          what = -1;
-        }
-      *mbuf++ = 'p';
-    }
   if((MODE_SECRET     & oldmode->mode) && !(MODE_SECRET     & mode.mode))
     {
       if (what != -1)